<!DOCTYPE html>
<html data-bs-theme="light" lang="en-US" dir="ltr">

<head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1, user-scalable=no">
    <title>Dashboard | RCM</title>
    <link href="https://vidya.indevconsultancy.in/anshu/whatsapp/irri/dashboard/assets/css/user.css" rel="stylesheet">
    <link href="https://vidya.indevconsultancy.in/anshu/whatsapp/irri/dashboard/assets/css/theme.css" rel="stylesheet">
    <link href="https://vidya.indevconsultancy.in/anshu/whatsapp/irri/dashboard/assets/css/style.css" rel="stylesheet">
    <link href="https://vidya.indevconsultancy.in/anshu/whatsapp/irri/dashboard/assets/css/media.css" rel="stylesheet">
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.3/dist/css/bootstrap.min.css" rel="stylesheet">
    <link rel="stylesheet" href="https://vidya.indevconsultancy.in/anshu/whatsapp/irri/dashboard/assets/css/all.min.css" />
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/flatpickr/dist/flatpickr.min.css">

    <script src="https://vidya.indevconsultancy.in/anshu/whatsapp/irri/dashboard/assets/js/jquery.min.js"></script>


    <style>
        .bg-primary {
            --falcon-bg-opacity: 1;
            background-color: rgba(var(--falcon-primary-rgb), var(--falcon-bg-opacity)) !important;
        }

        body {
            overflow-x: hidden !important;
        }

        html {
            width: 100%;
            overflow-x: hidden;
        }

        @media (max-width: 576px) {
            .logo-row {
                overflow-x: auto;
                white-space: nowrap;
            }

            .logo-row img {
                max-height: 40px;
                margin-right: 10px;
            }

            .vh-100 {
                height: 70vh !important;
            }

            #calendar .flatpickr-calendar {
                height: auto !important;
                border: unset !important;
                width: 315px !important;
            }
        }
    </style>
</head>

<body>
    <main class="main" id="top">
        <nav class="navbar navbar-light navbar-glass navbar-top navbar-expand-lg">
            <div class="w-100">
                <div class="container-fluid py-2">
                    <div class="d-flex justify-content-between align-items-center">
                        <div class="logo-row d-flex justify-content-center gap-4">
                            <img src="irri/dashboard/assets/images/logo/irri-logo.png" class="img-fluid" alt="IRRI">
                            <img src="irri/dashboard/assets/images/logo/nrri-logo.png" alt="NRRI Logo">
                            <img src="irri/dashboard/assets/images/logo/ouat-logo.png" alt="OUAT">
                            <img src="irri/dashboard/assets/images/logo/odisha-gov-logo.png" alt="Odisha Go Logo">
                        </div>

                    </div>
                </div>
                <hr class="my-0" />

            </div>
        </nav>
        <div class="content">
            <div class="container-fluid mt-4">
                <div class="row g-3 justify-content-center">
                    <div class="col-md-12 d-flex justify-content-center">
                        <div class="card shadow rounded-4">
                            <div class="card-body text-center">
                                <h2>Select a Date</h2>
                                <div id="calendar"></div>
                                <input type="hidden" class="form-control mx-auto" id="mobileNumber">
                                <!-- <button class="btn btn-primary btn-sm mt-3" id="submitBtn">Submit</button> -->
                            </div>
                        </div>
                    </div>
                </div>
            </div>

            <footer class="footer bg-dark">
                <div class="container-fluid">
                    <div class="row g-0 justify-content-between fs--1 py-3">
                        <div class="col-12 col-sm-auto text-center">
                            <p class="mb-0 text-white">Technology Partner: <a href="#"
                                    class="text-info text-decoration-none" target="_blank">Indev Consultancy Pvt. Ltd.</a></p>
                        </div>
                        <div class="col-12 col-sm-auto text-center">
                            <p class="mb-0 text-white">Terms & Conditions | Privacy Policy</p>
                        </div>
                    </div>
                </div>
            </footer>
        </div>
    </main>
    <script src="https://vidya.indevconsultancy.in/anshu/whatsapp/irri/dashboard/assets/js/bundle.min.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/flatpickr"></script>
    <script src="https://cdn.jsdelivr.net/npm/sweetalert2@11"></script>


</body>
<!-- Include SweetAlert2 -->
<script>
    flatpickr("#calendar", {
        inline: true,
        onChange: function(selectedDates, dateStr, instance) {
            Swal.fire({
                title: 'Confirm Date Selection',
                html: `You selected: <strong>${dateStr}</strong><br><br>Do you want to confirm?`,
                icon: 'question',
                showCancelButton: true,
                confirmButtonText: 'Yes',
                cancelButtonText: 'Cancel',
                reverseButtons: true
            }).then((result) => {
                if (result.isConfirmed) {
                    let mobnumber = $("#mobileNumber").val();
                    if (mobnumber !== '' && dateStr !== '') {
                        if (!isNaN(Date.parse(dateStr))) {
                            let parts = dateStr.split("-");
                            let formattedDate = `${parts[2]}-${parts[1]}-${parts[0]}`;
                            let encodedText = encodeURIComponent(formattedDate);
                            let phone = '7065000436';

                            // Detect platform
                            const ua = navigator.userAgent.toLowerCase();
                            let finalURL = '';

                            if (ua.includes('whatsapp')) {
                                if (ua.includes('whatsappbusiness')) {
                                    // WhatsApp Business
                                    finalURL = `https://wa.me/${phone}?text=${encodedText}`;
                                } else {
                                    // WhatsApp Messenger
                                    finalURL = `intent://send/?phone=${phone}&text=${encodedText}#Intent;package=com.whatsapp;scheme=smsto;end`;
                                }
                            } else if (/Android|iPhone|iPad|iPod/i.test(navigator.userAgent)) {
                                // Mobile browser
                                finalURL = `https://wa.me/${phone}?text=${encodedText}`;
                            } else {
                                // Desktop
                                finalURL = `https://web.whatsapp.com/send?phone=${phone}&text=${encodedText}`;
                            }

                            window.location.href = finalURL;

                        } else {
                            Swal.fire('Invalid Date', 'Please select a valid date.', 'error');
                        }
                    } else {
                        Swal.fire('Missing Info', 'Mobile number or date is missing.', 'warning');
                    }
                } else {
                    instance.clear();
                }
            });
        }
    });
</script>



<script>
    // Get values from the URL query string
    const urlParams = new URLSearchParams(window.location.search);
    const mob = urlParams.get('mob');
    $("#mobileNumber").val(mob);

    // $(document).on('click', "#submitBtn", function() {
    //     let dateInput = $("#dateInput").val();
    //     let mobnumber = $("#mobileNumber").val();

    //     if (mobnumber !== '' && dateInput !== '') {
    //         if (!isNaN(Date.parse(dateInput))) {
    //             $.ajax({
    //                 url: 'insert_date.php',
    //                 type: 'POST',
    //                 data: {
    //                     showing_date: dateInput,
    //                     user_number: mobnumber
    //                 },
    //                 success: function(response) {
    //                     let parts = dateInput.split("-");
    //                     let formattedDate = `${parts[2]}-${parts[1]}-${parts[0]}`;
    //                     let encodedDate = encodeURIComponent(formattedDate);
    //                     let phone = '7065000436';

    //                     let whatsappURL;

    //                     if (/Android|iPhone|iPad|iPod/i.test(navigator.userAgent)) {
    //                         whatsappURL = `https://wa.me/${phone}?text=${encodedDate}`;
    //                     } else {
    //                         whatsappURL = `https://web.whatsapp.com/send?phone=${phone}&text=${encodedDate}`;
    //                     }

    //                     window.location.replace(whatsappURL);
    //                 },
    //                 error: function() {
    //                     alert('An error occurred while saving the data.');
    //                 }
    //             });
    //         } else {
    //             alert('Invalid date format.');
    //         }
    //     } else {
    //         alert('Mobile number or date is missing');
    //     }
    // });
</script>

</html>